#!/usr/bin/perl 


# Comment this next line out (put a # in front of it) if you don't 
# have CGI.pm installed on your server.  Most servers have it, so don't worry.

use CGI::Carp qw(fatalsToBrowser);

### Get our config file
require "/home/tigertom/public_html/cgi-bin/emh/email_hustler_config.cgi";

### Get our library of routines
require "/home/tigertom/public_html/cgi-bin/emh/tigertom_lib.cgi";



######################## END OF SETUP! #######################

####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                           
# TigerTom's Email Hustler Script. Version: 1.3, October 2004.                 
#                                                                             
# Copyright 2001-2004 T. O' Donnell.  All Rights Reserved.                        
# http://www.tigertom.com/contact.htm                                      
#                                                                            
# This Perl script may be used and modified by any purchaser so               
# long as this copyright notice and the comments below remain intact.
# It may only be used on domains owned by the purchaser.                                                                         
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O' 
# Donnell from any liability that might arise from its use.                                                           
#                                                                           
# Selling the code for this program without prior written consent is       
# expressly forbidden.                                                     
# You must get permission from T. O' Donnell before redistributing this      
# software over the Internet or via any other medium.                                                            
# You may not redistribute an altered version of this program in any form,    
# via any medium.                                                             
#                                                                            
# In all cases copyright and header must remain intact.                     
#                                                                                                
# This Copyright is in full effect in any country that has International     
# Trade Agreements with the United Kingdom Of Great Britain.                 
#                                                                            
##############################################################################


###### The sub routines 



&parse_data;             # Parse the raw form data.


# Server Side Include Output / Insert code into web page
	if(!$FORM{'email'} && !$FORM{'name'} && !$FORM{'friend_email'} && !$FORM{'friend_name'} && !$FORM{'key'}) {
	&spin_the_reels;
	$slot_output =~ s/\\//g;
	print "Content-type: text/html\n\n";
	print "$slot_output";
	exit;
	} # End if


unless(($FORM{'action'} eq "unsubscribe" && $FORM{'email'}) || $FORM{'key'}) {
 &check_referer;		 # Check if someone's messing with the script.
 &check_required;         # Check required fields have been filled in.
		} # End unless

&check_email;            # Check basic validity of email address syntax.

# Process a double-opt-in subscriber:
		&check_for_key;

 
&check_for_duplicates;   # Check if they're in the database 



# unless($check_for_duplicates_done) {
# &check_for_duplicates;   # Check if they're in the database 
# } # End unless


	if ($FORM{'action'} eq "unsubscribe" && $FORM{'email'} && !$already_subscribed) {
	$title = "<CENTER>Not present.</CENTER>";
	$message = "<CENTER><B>$FORM{'email'}</B> is not in our database.</CENTER>";
	&output_page;
	 } # End if

        if ($FORM{'action'} eq "subscribe" && $FORM{'email'} && $already_subscribed) {
	$title = "<CENTER>Already subscribed.</CENTER>";
	$message = "<CENTER><B>$FORM{'email'}</B> is already in our database.</CENTER>";
	&output_page;
	 } # End if


	if ($FORM{'action'} eq "unsubscribe" && $FORM{'email'} && $already_subscribed) {
	&unsubscribe;
	&output_page;
	 } # End if

	
&decode_key;	         # Decode a key, if presented

&get_the_text;		 # Get the webmaster's email text.

&get_date2;	         # Get the date;

# Make a duplicate of their name, for messages
$their_name = $FORM{'name'};

##### Deduce their Christian name
## by removing all characters after the first space in the name: 
 $Christian_name = $their_name;
 $Christian_name =~ s/\s.+//g;

# Make the first letter upper-case (we're pedantic)
$Christian_name =~ s/\b(\w)/\U$1/g;

# Just in case we've messed it up (i.e. it's now blank)
 if ($Christian_name !~ /\w/){
 $Christian_name = $FORM{'name'};
	         } # end if


# @list=0;
# &debug;
# print "Name: $FORM{'name'}, Christian name: $Christian_name, Email: $FORM{'email'}, Key: $FORM{'key'}, $title, $message";
# exit;



	if($FORM{'email'} && $FORM{'key'} && !$already_subscribed) {
	&subscribe;
	&spin_the_reels;
	&their_email;
	&your_email;
	&output_page;
		} # End if




## If not, proceed ...

	if($FORM{'email'} && !$double_opt_in && !$already_subscribed && $FORM{'action'} eq "subscribe") {
	&subscribe;
	&spin_the_reels;
	&their_email;
	&your_email;
	&output_page;
		} # End if


	if($FORM{'email'} && !$FORM{'key'} && !$already_subscribed && $double_opt_in) {
	&their_email;
	} # End if


	if($FORM{'email'} && $FORM{'friend_email'} && !$FORM{'key'} && !$friend_already_subscribed) {
	&friend_email;
		} # End if

&output_page;	         # Output result
exit 0;                  # Make sure script action ends.


############################ End of Script action ####################################



### Check for duplicate email addresses	

sub check_for_duplicates {

  
        if ($FORM{'email'} || $FORM{'friend_email'}) {


        open (FILE, "<$subscriber_file") || die print "Error - cannot open $subscriber_file: $!";
              
              if($lockit){flock(FILE,2);}
             	@list = <FILE>;
              if($lockit){flock(FILE,8);}
	     	close(FILE);
	        foreach $line(@list) {
		chomp($line);
		if ($line =~ /$FORM{'email'}/i) {

$already_subscribed = 1;
$title = "<CENTER>Email address is present in our database.</CENTER>";
$message = "<CENTER><B>$FORM{'email'}</B> is already in our database, and will not be emailed.</CENTER>";

                     } # End if


	if ($FORM{'friend_email'} && $line =~ /$FORM{'friend_email'}/i) {

$friend_already_subscribed = 1;
$title = "<CENTER>Email address is present in our database.</CENTER>";
$message = $message . "<CENTER><B>$FORM{'friend_email'}</B> is already in our database, and will not be emailed.</CENTER>";
  
			} # End if

                   } # End if

	         } # End foreach

# $check_for_duplicates_done = 1;

} # End sub	      




##### Put the customer in the 'pending' database:

sub pending {
   
          open (FILE, ">>$pending_file") || die print "Error - cannot open $pending_file: $!";
                         
		         if($lockit){flock(FILE,2);}
		        print FILE "$string_encrypted|$their_name|$FORM{'email'}\n";
			 if($lockit){flock(FILE,8);}
		        close(FILE);
             
   	} # End sub    


sub check_for_key {

  
        if ($FORM{'key'}) {


        open (FILE, "<$pending_file") || die print "Error - cannot open $pending_file: $!";
              
              if($lockit){flock(FILE,2);}
             	@list = <FILE>;
              if($lockit){flock(FILE,8);}
	     	close(FILE);
	        foreach $line(@list) {
		chomp($line);
		if ($line =~ /$FORM{'key'}/) {

# $already_pending = 1;

($FORM{'key'},$FORM{'name'},$FORM{'email'})= split(/\|/, $line);

                     } # End if
		} # End foreach
	} # End if

    } # End sub




##### Subscribe or unsubscribe the customer's email address
##### to or from the email database:


sub subscribe {
   
          open (FILE, ">>$subscriber_file") || die print "Error - cannot open $subscriber_file: $!";
                         
		         if($lockit){flock(FILE,2);}
		        print FILE "$FORM{'name'}|$FORM{'email'}\n";
			 if($lockit){flock(FILE,8);}
		        close(FILE);
             
   	} # End sub    

sub unsubscribe {    
   	
        open (FILE, "$subscriber_file") || die print "Error - cannot open $subscriber_file: $!";
         if($lockit){
        flock(FILE,2);}
       	@list = <FILE>;
	 if($lockit){
        flock(FILE,8);}
	close(FILE);
	open (FILE, ">$subscriber_file") || die print "Error - cannot open $subscriber_file: $!";
         if($lockit){
	flock(FILE,2);}
	foreach $line (@list) {
		chomp($line);
		unless($line =~ /$FORM{'email'}/i) {
			print FILE "$line\n";
		} 
	    }
	 if($lockit){
        flock(FILE,8);}
	close(FILE);

$title = "<CENTER><B>$FORM{'email'}</B> has been unsubscribed.</CENTER>";
$message = "<CENTER>Your email address has been removed from our database.</CENTER>";


 } # End sub

### Get the webmaster's message to put in the emails

sub get_the_text {

open (REPLY, "$email_text") || die "Error - cannot open $email_text\n";
        if($lockit){
        flock(REPLY,2);}
	@text = <REPLY>;
        if($lockit){
        flock(REPLY,8);}
        close (REPLY);
	
		}

###### Email the sender of the message

sub their_email {  



## If we have a winner

if($we_have_a_winner) {

##### Now set winning mail message ##########

## You can insert text between the MESSAGE tags.

$email_message =<<MESSAGE;


This is to inform you that:

$their_name, $FORM{'email'}

has won the prize on the $owner_name email slot machine.

Congratulations!

*** You must REPLY to this email to claim your prize. ***


MESSAGE

      } # End if

########################

# $email_message = $email_message . "Message for $their_name, $FORM{'email'}, from $owner_name:\n\n";

$email_message = $email_message . "Dear $Christian_name,\n\n";


##### Ask them if they want to sign up to the mailing list:


#### If this is a double opt-in service, print the sign-up link

if ($double_opt_in && !$FORM{'key'}) { 

### ... Convert their email address into an encoded key, to stop bogus sign-ups.

## Get rid of spaces
$FORM{'email'} =~ s/ //g;

## Replace spaces in name with + signs
$FORM{'name'} =~ s/ /\+/g;

## Encrypt the email address
$string_encrypted = $FORM{'email'};
&string_encrypt;

	 $email_message = $email_message . "===============================================================\nYou are not yet subscribed!\n\nPlease click on this web address to get the $owner_name newsletter regularly. You may win a prize:\n$cgi_url?key=$string_encrypted\n";
	 $email_message = $email_message . "\n(AOL users should: \n<a href=\"$cgi_url?key=$string_encrypted\">Click here</a>)\n===============================================================\n\n";
	
	### $email_message = $email_message . "===============================================================\nYou are not yet subscribed!\n\nPlease click on this web address to get the $owner_name newsletter regularly. You may win a prize:\n$cgi_url?name=$FORM{'name'}&email=$FORM{'email'}&key=$string_encrypted\n";
	### $email_message = $email_message . "\n(AOL users should: \n<a href=\"$cgi_url?name=$FORM{'name'}&email=$FORM{'email'}&key=$string_encrypted\">Click here</a>)\n===============================================================\n\n";

# Put them in the 'pending' file
 &pending;

} # End if



# If customer has chosen to subscribe to our mailing list :

	if ($FORM{'action'} eq "subscribe" && !$FORM{'key'}) {

	$email_message = $email_message . "$their_name, <$FORM{'email'}> has requested to subscribe to\nthe $owner_name email newsletter.  ";
        $email_message = $email_message . "To *unsubscribe* at any time, just click on this link:\n$cgi_url?email=$FORM{'email'}&action=unsubscribe\n";
        $email_message = $email_message . "\n(AOL users can: \n<a href=\"$cgi_url?name=$FORM{'name'}&email=$FORM{'email'}&action=unsubscribe\">Click here to unsubscribe</a>)\n\n";

		 } # End if 

	


## Add the webmasters own text to the message:
$email_message = $email_message . "\n" . "@text" . "\n" . "--------------------------------". "\n\n";

## Replace + signs with spaces
$FORM{'name'} =~ s/\+/ /g;


## Tell them they've told a friend

if($FORM{'friend_email'}) {
$email_message = $email_message . "NOTE: $their_name has also sent this message to $FORM{'friend_name'}, $FORM{'friend_email'}.\n\n";
			} # End if

### Set email subject

if($we_have_a_winner) {
$subject = "$their_name, $FORM{'email'} has WON on the $owner_name email slot machine.";
        } # End if

elsif($losing_result) {
$subject = "Thank you, $their_name, for subscribing to the $owner_name email newsletter.";
        } # End if

else {$subject = "From $owner_name - please read.";}



### Re-set the recipient details for our generic library email routine
$recipient_email = $FORM{'email'};
$recipient_name = $their_name;
&send_email;

 	
	} # End sub


###### Email the webmaster

sub your_email {


### Re-set the recipient details for our generic library email routine

$recipient_email = $sender_email;
$recipient_name = $sender_name;

### Re-set the sender details for our generic library email routine

$sender_email = $FORM{'email'};
$sender_name = $their_name;

if($losing_result) {
$subject = "New subscriber $their_name, $FORM{'email'}";
        } # End if

if ($FORM{'action'} eq "unsubscribe" && $already_subscribed) {

	$email_message = "$their_name, <$FORM{'email'}> has been **unsubscribed**\nfrom the $owner_name email newsletter.\n" . $email_message;

 	} # End if

&send_email;
# &call_mama;
	} # End sub


####### Send another email to their friend

sub friend_email {

### Re-use code. Swop the friends details for the senders' details

$recipient_email = $FORM{'friend_email'};
$recipient_name = $FORM{'friend_name'};

### Make sure they know the email comes from a friend

$sender_email = $FORM{'email'};
$sender_name = $their_name;

## Set the email subject 

$subject = "Your free subscription to the $owner_name mailing list.";

### Dump the message (so it doesn't get doubled):

$email_message = "";

$email_message = $email_message . "This is a message from $FORM{'name'} sent via the $owner_name website.\n\n";

##### Convert their email address into an encoded key, to stop bogus sign-ups.

# Get rid of spaces
$FORM{'friend_email'} =~ s/ //g;

## Replace spaces in name with + signs
$FORM{'friend_name'} =~ s/ /\+/g;

$string_encrypted = $FORM{'friend_email'};
&string_encrypt;

$email_message = $email_message . "\n\nClick on this link to get the $owner_name email newsletter regularly (and maybe win a prize!):\n$cgi_url?name=$FORM{'friend_name'}&email=$FORM{'friend_email'}&key=$string_encrypted&action=subscribe\n\n";


$email_message = $email_message . "\n" . "@text" . "\n" . "--------------------------------". "\n\n";


## Replace + signs with spaces
$FORM{'friend_name'} =~ s/\+/ /g;

### Now (re)send the emails to the friend 

&send_email;
	

    } # End sub


# Run the slot machine

 sub spin_the_reels {


## First, put the lucky number 7 in the array:
@array = ('7');

## Then set the odds, by defining the number
## of other numbers in the array. Add numbers 
## to the array:

$counter = 0;
while($#array <= $odds) {
unless($counter == 7) {
push(@array, $counter);
          } # End unless
$counter++;
  }


# Modified fisher_yates_shuffle( \@array ) : 
# generate a random permutation of @array in place
    
sub fisher_yates_shuffle {
  
        my $array = shift;
        my $i;
        for ($i = @$array; --$i; ) {
            my $j = int rand ($i+1);
            next if $i == $j;
            @$array[$i,$j] = @$array[$j,$i];
              }
            }
## Randomise the order of the array 
 fisher_yates_shuffle( \@array );    # permutes @array in place



## If the first number of the array is the lucky number, we have a winner
if($array[0] == 7) {
	$we_have_a_winner = 1;



### Change the array to 777
$array[1] = "7";
$array[2] = "7";

####### Edit this with care! 

### Slot output for winner

$slot_output ="

<table width=\"100%\" border=\"5\" cellspacing=\"6\" cellpadding=\"7\" align=\"center\">
  <tr>
    <td bgcolor=\"#FFFFFF\" width=\"33%\"><FONT SIZE=\"5\" COLOR=\"#000000\"><CENTER>&nbsp;<B>$array[0]</B>&nbsp;</CENTER></FONT></td>
    <td bgcolor=\"#FFFFFF\" width=\"33%\"><FONT SIZE=\"5\" COLOR=\"#000000\"><CENTER>&nbsp;<B>$array[1]</B>&nbsp;</CENTER></FONT></td>
    <td bgcolor=\"#FFFFFF\" width=\"34%\"><FONT SIZE=\"5\" COLOR=\"#000000\"><CENTER>&nbsp;<B>$array[2]</B>&nbsp;</CENTER></FONT></td>
  </tr>
</table>

";

####

## Now set the output for the winner page
$title = "<CENTER><BLINK><MARQUEE>YOU WON!</MARQUEE></BLINK></CENTER>";
$message = "<CENTER>$slot_output</CENTER><BR><CENTER><H3>If you entered a valid email address you will be contacted with details of how to collect your prize.</H3><CENTER>";

		} # End if

##### 
else {

@array = ('7','$','BAR','7','$','BAR','7','$','BAR','7','$','BAR','7','$','BAR');

 fisher_yates_shuffle( \@array );

$losing_result = "$array[0]$array[1]$array[2]";

### Make sure we don't get a winning result by mistake:
	while ($losing_result eq "777") {
	fisher_yates_shuffle( \@array );
	$losing_result = "$array[0]$array[1]$array[2]";
      			} # End while

####### Edit this with care! ########

### Slot output for loser

$slot_output ="

<table width=\"100%\" border=\"5\" cellspacing=\"6\" cellpadding=\"7\" align=\"center\">
  <tr>
    <td bgcolor=\"#FFFFFF\" width=\"33%\"><FONT SIZE=\"5\" COLOR=\"#000000\"><CENTER>&nbsp;<B>$array[0]</B>&nbsp;</CENTER></FONT></td>
    <td bgcolor=\"#FFFFFF\" width=\"33%\"><FONT SIZE=\"5\" COLOR=\"#000000\"><CENTER>&nbsp;<B>$array[1]</B>&nbsp;</CENTER></FONT></td>
    <td bgcolor=\"#FFFFFF\" width=\"34%\"><FONT SIZE=\"5\" COLOR=\"#000000\"><CENTER>&nbsp;<B>$array[2]</B>&nbsp;</CENTER></FONT></td>
  </tr>
</table>

";

####


## Now set the output the loser page

$title = "<CENTER>Sorry, you need 777 to win :(</CENTER>";
$message = "<CENTER>$slot_output</CENTER>";
   
	 	
			}  # End else
	
  } # End sub          


