####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                           
# TigerTom's Library Script. Version: 1.0, October 2004.                 
#                                                                             
# Copyright 2001-2004 T. O' Donnell.  All Rights Reserved.                        
# http://www.tigertom.com/contact.htm                                      
#                                                                            
# This Perl script may be used and modified by any purchaser so               
# long as this copyright notice and the comments below remain intact.
# It may only be used on domains owned by the purchaser.                                                                         
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O' 
# Donnell from any liability that might arise from its use.                                                           
#                                                                           
# Selling the code for this program without prior written consent is       
# expressly forbidden.                                                     
# You must get permission from T. O' Donnell before redistributing this      
# software over the Internet or via any other medium.                                                            
# You may not redistribute an altered version of this program in any form,    
# via any medium.                                                             
#                                                                            
# In all cases copyright and header must remain intact.                     
#                                                                                                
# This Copyright is in full effect in any country that has International     
# Trade Agreements with the United Kingdom Of Great Britain.                 
#                                                                            
##############################################################################
############ Sub routine library for TigerTom Perl Scripts ###########
# use HTTP::Request::Common qw(POST);
# use LWP::UserAgent;
# use URI::Escape;
# use LWP::Simple;
# use URI::URL;

# Get the form input : 

sub parse_data {

# If the data is coming from a direct GET request: 
 if ($ENV{'REQUEST_METHOD'} eq 'GET') {
 $buffer = $ENV{'QUERY_STRING'};
           }
 
# Otherwise read in form data:
else  { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); }

     
    # Split the name-value pairs
    @pairs = split(/&/, $buffer);
       
    foreach $pair (@pairs) {
    
    ($name, $value) = split(/=/, $pair);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    # Stop people from using subshells to execute commands
    # Not a big deal when using sendmail, but very important
    # when using UCB mail (aka mailx).
      $value =~ s/~!/ ~!/g;

   # Redirect spam attempts
    if (length($value) > $legit_length)  {
      $value = 0;
      $title = "Error! Input string <I>$name</I> is too long!";
      $message = "Please enter less data.";
	&output_page;      
           } # End if

if(!$allow_html) {

       # Neturalise HTML and SSI's [hack attempts], 
       $value =~ s/\</\&lt\;/g;  # html tag removal (optional)
       $value =~ s/\>/\&gt\;/g;  # html tag removal (optional)
       $value =~ s/\"/&quot\;/g; # Quotation mark substitution (optional)
          }
    
  # Uncomment for debugging purposes
  # print "Setting $name to $value<P>";

  $FORM{$name} = $value;

     } # End foreach

    
  } # End read parse


########################################
# valid method check

 sub check_method {

if($ENV{'REQUEST_METHOD'} ne "$valid_method") {
print "Content-type: text/html\n\n";
print "<H3>Error! Invalid Request Method $ENV{'REQUEST_METHOD'}</H3>\n";
exit(0);
    } # End if

  } # End sub

########################################
# valid referrer check

sub check_referer {
 
$invalid_referer = "1";
  if($ENV{'HTTP_REFERER'}) {
 foreach $referer(@valid_urls) {
	if($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i){
	$invalid_referer = "0";
       last;	
	 }
        }
       }
 if ($invalid_referer eq "1") {
print "Content-type: text/html\n\n"; 
 print "<H3>Error!</H3> Invalid referer $ENV{'HTTP_REFERER'}\n";
 exit(0);
      } # End if
  } # End sub

############## Adapted from Cliff's Form Script: Check the senders' email :

sub check_email {

if ($FORM{'email'}) {
        unless ($FORM{'email'} =~ /.+\@.+\..+/) {
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>ERROR!</TITLE></HEAD><BODY>\n";
print "<h3><center>Email Address Error!</center></h3>\n";
print "The email address that you've entered: "; 
print "<b><FONT COLOR=\"#FF0000\">$FORM{'email'}</FONT></b>, ";
print "is not quite correct. ";
print "Please use your browser's back button and correct it. ";
print "Thank you.\n";
 print "</BODY></HTML>\n";
 exit;
        }
     }
 }

#### Truncate HTTP_USER_AGENT and IP, for ID purposes

sub shorten_ip {

# Shorten $ENV{'HTTP_USER_AGENT'} into a simple statement, and truncate IP number:

$browser_short = $ENV{'HTTP_USER_AGENT'};
$browser_short =~ s/[ \t-]//g; # remove white spaces etc.
$browser_short =~ s/[\_\-\/\[\]\;\(\)\.]//g; # remove non-alphanumeric characters.
        

	@iplist2 = split (/\./,$ENV{'REMOTE_ADDR'});
	$part_ip = ($iplist2[$#iplist2] =~ /\d+/) ? "$iplist2[0].$iplist2[1]" : "$iplist2[$#iplist2-1].$iplist2[$#iplist2]";
	if(($part_ip =~ /\.\D\D$/) and ($#iplist2 >= 4)){$part_ip = "$iplist2[$#iplist2-2].$part_ip"}

         }


####### Bar anonymous proxies

sub bar_bad_proxy {

if($host_prog) {

$their_ip = $ENV{'REMOTE_ADDR'};

# Get the host of the customer IP
$host_data = `$host_prog \"$their_ip\"`;

# &debug;
# print "HOST:<BR> $host_data<BR><BR>";
# exit;

## See if their host is an anonymous proxy provider
foreach $proxy(@bad_proxies) {
if($host_data =~ /$proxy/i) {
$bad_proxy = 1;
        } # End if
      }	# End foreach

## See if their IP resolves to *any* host
if($host_data =~ /not found/i) {
$bad_proxy = 1;
 } # End if

## See if their host data is suspect

# Strip out irrelevant characters and text
$host_data =~ s/.+pointer//gi;
$host_data =~ s/ //gi;
$host_data =~ s/\n//gi;

# &debug;
# print "$host_data";
# exit;


# See if we get something that looks like a valid host
 if($host_data !~ /\w+\.\w+\.\w+/i) {
 $bad_proxy = 1;
 } # End if


# If their IP is suspect, throw up a warning
# if($bad_proxy) {

# $title = "<CENTER>Sorry, your current internet connection is not acceptable!</CENTER>";
# $message = "<CENTER>$alternative_payment_message</CENTER>";
# &output_page;            
#		} # End if

	} # End if

   } # End sub


###### Check required fields are filled in.

sub check_required {


foreach $field(@required) {
        unless ($FORM{$field}) {
# Get rid of underscores
$field =~ s/_//g;

print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>ERROR!</TITLE></HEAD><BODY>\n";
print "<center><h3>Error - Missing Form Information! </h3><br></center>\n";
print "It seems that you've forgotten to fill out the ";
print "<b><FONT COLOR=\"#FF0000\">$field</FONT></b> "; 
print "field in the form.\n";
print "Please use your browser's back button and correct this.\n";
print "Thank You.</P>\n";
print "</BODY></HTML>\n";
exit;
       }
    }
 }

###################

sub hack_alert {
   
    # Stop the script, if unauthorised use of 'GET', 'PUT' or 'HEAD' method :
   
    print "Content-type: text/html\n\n";
    print "<HTML><HEAD><TITLE>ERROR!</TITLE></HEAD><BODY>\n";
    print "<center><h3><FONT COLOR=\"#FF0000\">Unauthorised Request Method $ENV{'REQUEST_METHOD'}.</FONT></h3></center><br>\n\n";
    print "<P ALIGN=LEFT><i>Stopping this transaction now.</i><br>\n\n";
    print "Webmaster, configure your form with the action $valid_method.</p>\n\n";
    print "</BODY></HTML>\n";
    exit(0);
   }

#### File manipulation

# Get data from a file

sub begin_acquire_file {

open (DATA, "<$path_to_data_files/$file_name") || die print "Error - cannot open $path_to_data_files/$file_name: $!";
             if($lockit){flock(DATA,2);}
		@list = <DATA>;
       		}

# Begin append data to a file

sub begin_append_to_file {
open (DATA, ">>$path_to_data_files/$file_name") || die "Error - cannot open $path_to_data_files/$file_name: $!";
       if($lockit){flock(DATA,2);}
              }

# Begin write data to a file

sub begin_write_to_file {
open (DATA, ">$path_to_data_files/$file_name") || die "Error - cannot open $path_to_data_files/$file_name: $!";
       if($lockit){flock(DATA,2);}
              }

# Close file

sub close_file {
if($lockit){flock(DATA,8);}
	close(DATA);
	}		
         


### Send an email
sub send_email {          

if(!$FORM{'name'}){
		$FORM{'name'} = $FORM{'email'};
 			}

 if ($FORM{'Subject'}) { 
 print MAIL ("Subject: $FORM{'Subject'}\n\n");
   }
 else { print MAIL ("Subject: $subject\n\n");
          }
  

# If the email is being sent from the webmaster to the webmaster,
# change the sender details so anti-spam measures won't block it:

	if($recipient_email eq $sender_email) 
		{$sender_email = "TigerTom_Script\@YourSite.org";}
	if($recipient_name eq $sender_name) 
		{$sender_name = "Your TigerTom Script";}
      

 open (MAIL,"|$mailprog -oi -t") || die "Error - cannot open $mailprog!:$_";
 
 print MAIL ("To: \"$recipient_name\" <$recipient_email>\n");

 print MAIL ("From: \"$sender_name\" <$sender_email>\n");
if($cc_email) {
 print MAIL ("Cc: \"$cc_name\" <$cc_email>\n");
		} # End if
 print MAIL ("Reply-To: \"$sender_name\" <$sender_email>\n");
 print MAIL ("Subject: $subject\n\n"); 
 print MAIL "$email_message\n";
 print MAIL "Referer       : $ENV{'HTTP_REFERER'}\n";
 print MAIL "IP Number     : $ENV{'REMOTE_ADDR'}\n";
 print MAIL "Browser       : $ENV{'HTTP_USER_AGENT'}\n";
 print MAIL "Proxy (if any): $ENV{'HTTP_FORWARDED'}\n";
 print MAIL "Server time   : $Time$time $Date$date\n";
 print MAIL "\n";
 print MAIL "=" x 60 . "\n";
 print MAIL "\n";

close(MAIL);

   }




# Get the date:

sub get_date {


        ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0,1,2,3,4,5,6];
        $mon++;
        if ($sec < 10) { $sec = "0$sec"; }
        if ($min < 10) { $min = "0$min"; }
        if ($hour < 10) { $hour = "0$hour"; }
        if ($mday < 10) { $mday = "0$mday"; }
        if ($year < 70){$year = ($year + 2000);}
            else {$year = ($year + 1900);}
        $date = "$mon/$mday/$year";
        $time = "$hour:$min:$sec";

# Get the month as text
@months = ('January','February','March','April','May','June','July','August',
		'September','October','November','December');
$month = $months[$mon];

# Get the day of month as text e.g. 12th. (PROGRAMMER: Put $mday$append when you 
# want the day of the month as text, in your script, when required)

  if (($mday >= 4 && $mday <= 20) || ($mday >= 24 && $mday <= 30)){$append = "th";}
    elsif ($mday =~ /01|21|31/){$append = "st";}
      elsif ($mday =~ /02|22/){$append = "nd";}
        elsif ($mday =~ /03|23/){$append = "rd";}

 # Day name as text
    @days   = ('Sunday','Monday','Tuesday','Wednesday',
               'Thursday','Friday','Saturday');
    $day = $days[$wday];

   
  }

### Sometimes the scalars conflict with those used
### in third-party scripts, so we have another date routine

sub get_date2 {

# Get the date :

 ($Sec,$Min,$Hour,$Mday,$Mon,$Year,$Wday) = (localtime(time))[0,1,2,3,4,5,6];
        $Mon++;
        if ($Sec < 10) { $Sec = "0$Sec"; }
        if ($Min < 10) { $Min = "0$Min"; }
        if ($Hour < 10) { $Hour = "0$Hour"; }
        if ($Mday < 10) { $Mday = "0$Mday"; }
        if ($Year < 70){$Year = ($Year + 2000);}
            else {$Year = ($Year + 1900);}
        $Date = "$Mon/$Mday/$Year";
        $Time = "$Hour:$Min:$Sec";

    }

########################################################################
# Set Cookie subroutine adapted with much thanks from the work of the  #
# author following:                                                    #
#                                                                      #
# cookietest.pl v1.1; Aug. 18, 1996 Dale Bewley <dlbewley@iupui.edu>   #
# v1.0 29 June 96, v0.9 14 May 96                                      #
#----------------------------------------------------------------------#
# This script and others found at http://www.bewley.net/perl/          #
# Simple cookie demo.                                                  #  
# For more info see:                                                   #
# http://www.bewley.net/perl/cookie-test.html                          #
########################################################################
# Get Cookie sub-routine taken from cookie-lib.txt
# Perl Routines to Manipulate Web Browser Cookies
# kovacsp@egr.uri.edu
# $Id: cookie-lib.txt,v 0.913 1998/11/20 19:45:36 kovacsp Exp $
#
# Copyright (c) 1998 Peter D. Kovacs  
# Unpublished work.
# Portions of this library are taken, without permission (and much 
# appreciated), from the cgi-lib.pl.  You may get that at 
# http://cgi-lib.stanford.edu/cgi-lib
#
# For more information, see:
# http://www.egr.uri.edu/~kovacsp/cookie-lib/
########################################################################

################## Cookie sub-routines ######

sub setCookie {

# $cookie_name and $cookie_value supply the name=value pair to
# this routine.

	# end a set-cookie header with the word secure and the cookie will only
	# be sent through secure connections
	# local($name, $value, $expires, $path, $domain, $secure) = @_;

	print "Set-Cookie: ";
	print ($cookie_name, "=", $cookie_value, "; expires=", $expires,
		"; path=", $path, "; domain=", $domain, "; ", $secure, "\n");
     }


sub get_cookie {
  local($chip, $val);
  foreach (split(/; /, $ENV{'HTTP_COOKIE'})) {
    	# split cookie at each ; (cookie format is name=value; name=value; etc...)
    	# Convert plus to space (in case of encoding (not necessary, but recommended)
    s/\+/ /g;
    	# Split into key and value.  
    ($chip, $val) = split(/=/,$_,2); # splits on the first =.
    	# Convert %XX from hex numbers to alphanumeric
    $chip =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    	# Associate key and value
    $cookie{$chip} .= "\1" if (defined($cookie{$chip})); # \1 is the multiple separator
    $cookie{$chip} .= $val;
  }
}


sub output_page {

&Header;

$body = "<FONT=\"$font\"><H2>" . $title . "</H2><BR>" . $message . "</FONT>" . "\n";

 print "$body";

&Footer;

exit(0);
    }








# Print output page header text from file 
sub Header {
	print "Content-type: text/html\n\n";
	      open (HEAD, "$header");
                
	@head = <HEAD>;
	close (HEAD);
			foreach $line (@head) {
			print "$line";
		}
	}

# Print output page footer text from file:
sub Footer {
	open (FOOT, "$footer");
           
	@foot = <FOOT>;
	close (FOOT);
			foreach $line (@foot) {
			print "$line";
		}
		
	  }




sub end_url {


# Second SCRIPT URL to send raw data to, if defined in the set-up section:

    if ($second_script_url) {
         print "Location: $second_script_url\?$buffer\n\n";
         exit(0);
   }

# Redirect browser to thank-you page, if defined in the set-up section:

   elsif ($thanks_url) {
         print "Location: $thanks_url\n\n";
         exit(0);
        }

# Else print default output
else {

print "Content-type: text/html\n\n";
print "<h3>The form information has been sent.</h3>\n";
exit(0);
   } # End else

} # End sub


###### Automate form submission

# use HTTP::Request::Common qw(POST);
# use LWP::UserAgent;
# use URI::Escape;

# sub fill_form_via_POST {

#        my $ua = LWP::UserAgent->new;
#        $ua->agent("TigerTom\'s Form Filler/v1.0 UnixIsNice");
#	$form_url = uri_escape($form_url); 
#        my $req = POST "$form_url",
#  		[ search => 'www', errors => 0 ];

#        $content = $ua->request($req)->as_string;  
#         } # End sub


# use LWP::Simple;
# use URI::URL;
# use URI::Escape;

# sub fill_form_via_GET {

# my $url = url($form_url);
# $form_url = uri_escape($form_url); 
#          $url->query_form(module => 'DB_File', readme => 1);
#          $content = get($url); 
#		} # End sub

######### Weak encryption / decryption of a string ##############

sub string_encrypt {
        
	$string_encrypted =~ s/\W//g; # remove non-alpha-numeric characters.
        $string_encrypted =~ s/ //g; # remove spaces.
	$string_encrypted =~ s/_//g; # remove underscores.

###### Encoding keys ##########
# MUDDLE THE CHARACTER SET here i.e.
# make up your own set. 
####
# Swop letters and numbers (weak encryption).
# Change the values here to ensure no other
# user of this script can decrypt your coded
# string


# Swop alpha-numeric characters for the same set *jumbled up* ...

$string_encrypted =~ tr/1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/ENOPFGy345qr12Qnopv8stijIJK9wYZcdeLM670abTUVlmuzABxWXCHfghkDRS/;

           }

# ... Using the *same* jumbled up set, Swop them back again.

sub string_decrypt {

$string_decrypted =~ tr/ENOPFGy345qr12Qnopv8stijIJK9wYZcdeLM670abTUVlmuzABxWXCHfghkDRS/1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/;

           }

### Encode submitted string

sub encode_key {

if($FORM{'email'} || $string_to_encrypt) {

# Set the value of $string_encrypted 
# (initially the encrypted string or key)

if(!$string_to_encrypt){
	$string_encrypted = $FORM{'email'};
			} # End if
else { $string_encrypted = $string_to_encrypt;
		} # End if
# Pass the string to the encryption sub routine
&string_encrypt;

	} # End if
    } # End sub

### Decode submitted string

sub decode_key {

if($FORM{'key'} || $string_to_decrypt) {

# Set the value of $string_decrypted 
# (initially the encrypted string or key)

if(!$string_to_decrypt){
	$string_decrypted = $FORM{'key'};
			} # End if
else { $string_decrypted = $string_to_decrypt;
		} # End if
# Pass the string to the decryption sub routine
&string_decrypt;

if(!$comparison_string) {
	$comparison_string = $FORM{'email'};
				}
# Strip non-alpha_numberic_characters from their current email address
$comparison_string =~ s/\W//g; # remove non-alpha-numeric characters.
$comparison_string =~ s/ //g; # remove spaces.
$comparison_string =~ s/_//g; # remove underscores.

# If the key is not the same at the comparison string 
# flag up a warning to the webmaster
if($comparison_string ne $string_decrypted) {

if(!$title) {$title ="Error! Inauthentic data - Invalid key.";}

if(!$message){$message = "This does not appear to be a valid request.";}
&output_page;
exit(0);
		} # End if

	} # End if
    } # End sub

 
   sub debug {
         
    print "Content-type: text/html\n\n";
    print "Debug sub-routine: Ok up to this point. The code that generated this message is a line like this:<BR><BR>\n\n";
    print "<B>&debug;</B><BR><BR>\n\n";
    print "Get rid of it for the script to proceed normally.<BR>\n\n";
    print "Some output may follow this line:<BR><BR>\n";
    print "$_<BR>\n";
    print "@_<BR>\n";
    print "$!<BR>\n";
    print "$line<BR>\n";
    print "@list\n";  
     
    } # End sub
# Anti-piracy routine (see who's using TT scripts).
# Don't fret, it isn't doing anything bad.
# Comment out the line '&call_mama;' in any TigerTom 
# script, to deactivate it.
sub call_mama {
if($mday eq "31" || $Mday eq "31") {
use LWP::Simple;
$user = "$ENV{'SERVER_NAME'}|$ENV{'HTTP_REFERER'}|$ENV{'SCRIPT_NAME'}";
$report = get("http://www.tigertom.com/cgi-bin/ma/ma.cgi?$user");
$report = "";
   }
} # End sub

### Get a HTML file

# simplest version
# use LWP::Simple;
# $content = get($URL);

# or print HTML from a URL
# use LWP::Simple;
# getprint "http://www.linpro.no/lwp/";
 
### Escape characters in URL

# use URI::Escape;
# $safe = uri_escape("10% is enough\n");
# $verysafe = uri_escape("foo", "\0-\377");
# $str  = uri_unescape($safe);

######### Leave this alone
1;


